' GDI Draw test by Julien Moog
' julien.moog@laposte.net
' Credits to:
'
' A form designer the one used in the RapidQ IDE
' Copyright (c) 2014 cxs77
' cxs77@yahoo.com
'
' No warranties or guarantees of any kind; use at your own risk.
'
' If you do use the code, please give me credit. THanks.
'
' KPD-Team 1998
' URL: http://www.allapi.net/
' E-Mail: KPDTeam@Allapi.net
    

$apptype gui
$typecheck on

$Include "windows.inc"
$INclude "RapidQ2.inc"

'used with fnWeight
'Const FW_DONTCARE = 0
'Const FW_THIN = 100
'Const FW_EXTRALIGHT = 200
'Const FW_LIGHT = 300
'Const FW_NORMAL = 400
'Const FW_MEDIUM = 500
'Const FW_SEMIBOLD = 600
'Const FW_BOLD = 700
'Const FW_EXTRABOLD = 800
'Const FW_HEAVY = 900
'Const FW_BLACK = FW_HEAVY
'Const FW_DEMIBOLD = FW_SEMIBOLD
'Const FW_REGULAR = FW_NORMAL
'Const FW_ULTRABOLD = FW_EXTRABOLD
'Const FW_ULTRALIGHT = FW_EXTRALIGHT
''used with fdwCharSet
'Const ANSI_CHARSET = 0
'Const DEFAULT_CHARSET = 1
'Const SYMBOL_CHARSET = 2
'Const SHIFTJIS_CHARSET = 128
'Const HANGEUL_CHARSET = 129
'Const CHINESEBIG5_CHARSET = 136
'Const OEM_CHARSET = 255
''used with fdwOutputPrecision
'Const OUT_CHARACTER_PRECIS = 2
'Const OUT_DEFAULT_PRECIS = 0
'Const OUT_DEVICE_PRECIS = 5
''used with fdwClipPrecision
'Const CLIP_DEFAULT_PRECIS = 0
'Const CLIP_CHARACTER_PRECIS = 1
'Const CLIP_STROKE_PRECIS = 2
''used with fdwQuality
'Const DEFAULT_QUALITY = 0
'Const DRAFT_QUALITY = 1
'Const PROOF_QUALITY = 2
''used with fdwPitchAndFamily
'Const DEFAULT_PITCH = 0
'Const FIXED_PITCH = 1
'Const VARIABLE_PITCH = 2
''used with SetBkMode
'Const OPAQUE = 2
'Const TRANSPARENT = 1

'Const LOGPIXELSY = 90
'Const COLOR_WINDOW = 5

declare sub graphclicked
DECLARE SUB Timer1_onTimer
declare sub ovl_paint
declare sub drawselrect
declare SUB graphmousedown(Button AS INTEGER , x AS INTEGER , y AS INTEGER)

DEFLNG blue = RGB(0 , 0 , 255)
DEFLNG white = RGB(255 , 255 , 255)

defint mouseposx,mouseposy,DownX,DownY,mousediffx,mousediffy,relativecordx,relativecordy

defint graphclick=0
DIM bmOvl AS QBITMAP

dim Timer1 AS QTIMER
timer1.Interval = 10
timer1.OnTimer = Timer1_onTimer
timer1.enabled=0

create frmmain as qform
caption="Draw GDI test"
height=480
width=640

create graph as qcanvas
height=frmmain.clientheight
width=frmmain.clientwidth
'onpaint=DrawSelRect
onclick=graphclicked
OnMouseDown = graphmousedown
end create

end create

SUB Timer1_onTimer
mouseposx=screen.mousex-mousediffx
mouseposy=screen.mousey-mousediffy
drawselrect
END SUB    

sub graphclicked
if graphclick=0 then
graphclick=1
DownX=relativecordx
DownY=relativecordy
Timer1.enabled=1
exit sub
end if
if graphclick=1 then
graphclick=0
Timer1.enabled=0
exit sub
end if

end sub

SUB PaintChart  'Assign this to the QChart.OnPaint Event
        'Draws Buffer.BMP to Canvas
                
            graph.Draw(0 , 0 , bmOvl.BMP)
       

    END SUB

SUB DrawSelRect
    DIM rcDraw AS Rect
    rcDraw.Top = DownY
    rcDraw.Left = DownX
    rcDraw.Right = mouseposx
    rcDraw.Bottom = mouseposy
 
    bmOvl.Width = graph.Width
    bmOvl.Height = graph.Height
    bmOvl.fillrect(0 , 0 , 640,480,white)
    
    deflng hSrcDC = bmOvl.Handle
    
    'create pen with style, width and color
    deflng hPen = CreatePen(PS_DOT , 1 , blue)
    SelectObject(hSrcDC , hPen)
     
    ' draw line
    'MoveToEx(hSrcDC , rcDraw.Left , rcDraw.Top , 0)
    'LineTo(hSrcDC , rcDraw.Right , rcDraw.Bottom)
    
    ' draw rectangle
    Rectangle(hSrcDC , rcDraw.Left , rcDraw.Top , rcDraw.Right , rcDraw.Bottom)
    
    ' write text
    Dim intCount As Integer, strString As String
    strString = "Cool, text on screen !"    
    'Draw the text on the screen
    SetTextColor hSrcDC, blue
    'Set the bitmap's backmode to transparent
    SetBkMode hSrcDC, TRANSPARENT
    defint nSize=24    
    deflng nDegrees=0
    deflng CreateMyFont = CreateFont(-MulDiv(nSize, GetDeviceCaps(hSrcDC, LOGPIXELSY), 72), 0, nDegrees * 10, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH, "Times New Roman")
    SelectObject(hSrcDC , CreateMyFont)    
    TextOut hSrcDC, rcDraw.Left, rcDraw.Top, strString, Len(strString)

    
    'bmOvl.Line(rcDraw.Left , rcDraw.Top , rcDraw.Right , rcDraw.Bottom, 0)
    'BitBlt(graph.handle , 0 , 0 , graph.Width , graph.Height , hSrcDC , 0 , 0 , SRCCOPY)
    'ReleaseDC(hSrcDC , hSrcDC)
    
    ' delete pen object
    DeleteObject(hPen)
    
    PaintChart
    'graph.repaint

END SUB      

SUB graphmousedown(Button AS INTEGER , x AS INTEGER , y AS INTEGER)

    relativecordx = x
    relativecordy = y
    mousediffx=screen.mousex-relativecordx
    mousediffy=screen.mousey-relativecordy    
    
end sub      

frmmain.showmodal